unit ConvertU1;
{ A quick program to convert .DAT files to .COM files
  from the ASM8080 assembler
  Laurie Boshell
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Label3: TLabel;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


FUNCTION HexToDec(Hex:STRING):LongInt;
  Function MyPower(base,p:integer):longint;
  Begin
    case p of
      0 : Result := 1;
      1 : Result := base;
      2 : Result := base * base;
      3 : Result := Base*base*base;
      4 : Result := base*base*base*base;
      5 : Result := base*base*base*base*base;
      6 : Result := base*base*base*base*base*base;
      7 : Result := base*base*base*base*base*base*base;
      end;
  end;
VAR
   T1,T2,Dec   :       integer;
      Error    :       Boolean;
BEGIN
  Error:=False;
  T1:=0;T2:=0;DEC:=0;
  FOR T1:=1 TO LENGTH(Hex) DO
  BEGIN
   T2:=Length(Hex)-T1;
   CASE Hex[T1] OF
   '0'  : DEC:=DEC+0;
   '1'  : DEC:=DEC+  myPower(16,T2);
   '2'  : DEC:=DEC+2*myPower(16,T2);
   '3'  : DEC:=DEC+3*myPower(16,T2);
   '4'  : DEC:=DEC+4*myPower(16,T2);
   '5'  : DEC:=DEC+5*myPower(16,T2);
   '6'  : DEC:=DEC+6*myPower(16,T2);
   '7'  : DEC:=DEC+7*myPower(16,T2);
   '8'  : DEC:=DEC+8*myPower(16,T2);
   '9'  : DEC:=DEC+9*myPower(16,T2);
   'A','a' : DEC:=DEC+10*myPower(16,T2);
   'B','b' : DEC:=DEC+11*myPower(16,T2);
   'C','c' : DEC:=DEC+12*myPower(16,T2);
   'D','d' : DEC:=DEC+13*myPower(16,T2);
   'E','e' : DEC:=DEC+14*myPower(16,T2);
   'F','f' : DEC:=DEC+15*myPower(16,T2);
   ELSE Error:=True;
   END;
  END;
  HexToDec:=Dec;
  IF Error THEN HexToDec:=0;
END; { HexToDec }


procedure TForm1.Button1Click(Sender: TObject);
begin
  If OpenDialog1.Execute then Begin
    Label2.Caption := OpenDialog1.FileName;
    Label3.Caption := ChangeFileExt(Label2.Caption, '.COM');
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var infile: TextFile;
    outFile: File of byte;
    s:string; b, zero:byte; Address, NewAddress: Integer;
begin
  Memo1.Clear;
  Memo1.Lines.Add('Convert '+Label2.Caption+' to '+Label3.caption);
  Zero :=0;
  AssignFile(infile,Label2.Caption);
  Reset(infile);
  AssignFile(outFile,LAbel3.Caption);
  Rewrite(outfile);
  Address := $0100;   //assume start at 0x0100 (CP/M start addr)
  While not eof(infile) do begin
    Readln(infile,s);
    if s[1] = ':' then begin
      NewAddress := HexToDec(copy(s,2,4));
      (*
      While Address < NewAddress do begin
        //Memo1.Lines.Append();
        Write(outfile,zero); inc(Address);
        end;
      *)
      Address := NewAddress;
      Memo1.Lines.Add(s);
      end // S[1] = ':'
    else //first char was not ':'
      begin
      Memo1.Lines.Append(s);
      b:=HexToDec(s);
      Seek(outfile,Address-$0100);
      Write(outfile,b);
      Inc(Address);
      end;
    end;
  CloseFile(OutFile);
  CloseFile(infile);
  ShowMessage('Complete. Output file is '+Label3.caption);
  end;
end.
